package com.ekexiu.operation.service;

import com.ekexiu.portal.dao.DiscoverBannerDao;
import com.ekexiu.portal.dao.UserDao;
import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.util.jdbc.JdbcUtil;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;

@Path("/operation/statist")
public class StatistService {

	@Autowrie
	private UserDao userDao;
	@Autowrie
	private DiscoverBannerDao discoverBannerDao;

	public UserDao getUserDao() {
		return userDao;
	}

	public void setUserDao(UserDao userDao) {
		this.userDao = userDao;
	}

	public DiscoverBannerDao getDiscoverBannerDao() {
		return discoverBannerDao;
	}

	public void setDiscoverBannerDao(DiscoverBannerDao discoverBannerDao) {
		this.discoverBannerDao = discoverBannerDao;
	}

	@Get
	@Path("/user")
	public Map<String,Object> user(@JdbcConn Connection con)throws SQLException{
		Map<String,Object> map = new HashMap<String,Object>();
		map.put("all",this.userDao.countAll(con));
		map.put("actived", this.userDao.countActived(con));
		map.put("byRole",JdbcUtil.queryMaps(con, "select authentication code,count(1) num from professor group by code"));
		map.put("byType",JdbcUtil.queryMaps(con, "select auth_type code,count(1) num from professor group by code"));
		return map;
	}

	@Post
	@Path("/bannerClick")
	public void bannerClick(@JdbcConn(true) Connection con, long id) throws SQLException {
		this.discoverBannerDao.incClicks(con, id);
	}
}
