package com.ekexiu.portal.dao;

import com.ekexiu.portal.po.UserOpenId;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.operator.DeleteWith;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectList;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;

@DAO
public interface UserOpenIdDao {
    @Insert
    int insert(Connection con, UserOpenId user) throws SQLException;

    @DeleteWith
    @From(UserOpenId.class)
    int delete(Connection con, String userid) throws SQLException;
    @DeleteWith
    @From(UserOpenId.class)
    int delete(Connection con, String oauthType, String openid) throws SQLException;

    @SelectList
    List<UserOpenId> query(Connection con, String userid) throws SQLException;

    @SelectOne
    @Nullable
    UserOpenId queryByUserid(Connection con, String oauthType, String userid) throws SQLException;
    
    @SelectOne
    @Nullable
    UserOpenId queryByOpenid(Connection con, String oauthType, String openid) throws SQLException;
}
