package com.ekexiu.portal.leavemsg;

import org.jfw.apt.orm.annotation.entry.Column;
import org.jfw.apt.orm.annotation.entry.PrimaryKey;
import org.jfw.apt.orm.annotation.entry.Table;
import org.jfw.apt.orm.core.enums.DE;

import com.ekexiu.portal.basepo.ModifyTimeSupported;

@PrimaryKey("id")
@Table
public class LeaveMsg implements ModifyTimeSupported {

	private String id;
	private String cnt;
	private String refId;
	private String refType;
	private String top;
	private String parent;
	private String sender;
	private String reciver;
	private String createTime;
	private String modifyTime;
	private String state;
	private long  agreeCount;
	
	private transient String timeDesc;
	
	@Column(DE.text_de)
	public String getTimeDesc() {
		return timeDesc;
	}
	public void setTimeDesc(String timeDesc) {
		this.timeDesc = timeDesc;
	}
	/**
	 * id
	 * @return
	 */
	@Column(DE.id_32)
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	/**
	 * 留言内容
	 * @return
	 */
	@Column(DE.text_de)
	public String getCnt() {
		return cnt;
	}
	public void setCnt(String cnt) {
		this.cnt = cnt;
	}
	/**
	 * 留言主体ID ,  文章ID,论文ID,专利ID,提问ID
	 * @return
	 */
	@Column(DE.text_de)
	public String getRefId() {
		return refId;
	}
	public void setRefId(String refId) {
		this.refId = refId;
	}
	/**
	 * 留言主体类型,1:文章   2:论文   3:专利      4:回答
	 * @return
	 */
	@Column(DE.singleChar)
	public String getRefType() {
		return refType;
	}
	public void setRefType(String refType) {
		this.refType = refType;
	}
	/**
	 * 顶级留言ID
	 * @return
	 */
	@Column(DE.text_de)
	public String getTop() {
		return top;
	}
	public void setTop(String top) {
		this.top = top;
	}
	/**
	 * 上级留言ID
	 * @return
	 */
	@Column(DE.Text_de)
	public String getParent() {
		return parent;
	}
	public void setParent(String parent) {
		this.parent = parent;
	}
	/**
	 * 留言人ID
	 * @return
	 */
	@Column(DE.text_de)
	public String getSender() {
		return sender;
	}
	public void setSender(String sender) {
		this.sender = sender;
	}
	/**
	 * 上级留言的留言人ID
	 * @return
	 */
	@Column(DE.Text_de)
	public String getReciver() {
		return reciver;
	}
	public void setReciver(String reciver) {
		this.reciver = reciver;
	}
	@Column(DE.text_de)
	public String getCreateTime() {
		return createTime;
	}
	public void setCreateTime(String createTime) {
		this.createTime = createTime;
	}
	public String getModifyTime() {
		return modifyTime;
	}
	public void setModifyTime(String modifyTime) {
		this.modifyTime = modifyTime;
	}
	/**
	 * 状态  1： 发布中   0 ：删除的
	 * @return
	 */
	@Column(DE.singleChar)
	public String getState() {
		return state;
	}
	public void setState(String state) {
		this.state = state;
	}
	/**
	 * 留言语的点赞数
	 * @return
	 */
	@Column(DE.long_de)
	public long getAgreeCount() {
		return agreeCount;
	}
	public void setAgreeCount(long agreeCount) {
		this.agreeCount = agreeCount;
	}
}
