package com.ekexiu.portal.leavemsg;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.annotation.DefaultValue;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.Column;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.IncludeFixSet;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.SetSentence;
import org.jfw.apt.orm.annotation.dao.method.Where;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.LimitSelect;
import org.jfw.apt.orm.annotation.dao.method.operator.QueryVal;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.GreaterThan;
import org.jfw.apt.orm.annotation.dao.param.GroupSqlColumn;
import org.jfw.apt.orm.core.defaultImpl.IntHandler;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;

@DAO
public interface LeaveMsgDao {

	@Insert
	int insert(Connection con, LeaveMsg msg) throws SQLException;

	@UpdateWith
	@From(LeaveMsg.class)
	@SetSentence("STATE = '0'")
	@Where("STATE = '1' ")
	@IncludeFixSet
	int logicDelete(Connection con, String id) throws SQLException;

	@UpdateWith
	@From(LeaveMsg.class)
	@SetSentence("AGREE_COUNT = AGREE_COUNT + 1")
	@IncludeFixSet
	int incAgree(Connection con, String id) throws SQLException;

	@LimitSelect
	@Where("STATE='1'")
	@OrderBy("ORDER BY TIME_DESC ASC")
	List<LeaveMsg> query(Connection con, String refId, String refType, @GreaterThan String timeDesc, int rows) throws SQLException;

	@Nullable
	@SelectOne
	LeaveMsg query(Connection con, String id) throws SQLException;

	@Insert
	int insert(Connection con, LeaveMsgAgreeRec rec) throws SQLException;

	@Nullable
	@SelectOne
	LeaveMsgAgreeRec queryAgreeRec(Connection con, String id, String uid) throws SQLException;

	@LimitSelect
	@OrderBy("ORDER BY TIME_DESC ASC")
	List<LeaveMsg> queryWithParent(Connection con, String parent, @GreaterThan String timeDesc, int rows) throws SQLException;

	@LimitSelect
	@OrderBy("ORDER BY TIME_DESC ASC")
	List<LeaveMsg> queryWithTop(Connection con, String top,
			@GroupSqlColumn(handlerClass = StringHandler.class, isAnd = false, value = { "SENDER=?", "RECIVER=?" }, force = true) String sid,
			@GroupSqlColumn(handlerClass = StringHandler.class, isAnd = false, value = { "SENDER=?", "RECIVER=?" }, force = true) String rid,
			 @GreaterThan String timeDesc,int rows) throws SQLException;

	@QueryVal
	@From(LeaveMsg.class)
	@DefaultValue("0")
	@Column(value="COUNT(ID)",handlerClass=IntHandler.class)
	@Where("STATE='1'")
	int queryCount(Connection con,String refType,String refId) throws SQLException;
	
	
}
