package com.ekexiu.portal.notify;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.SetSentence;
import org.jfw.apt.orm.annotation.dao.method.Where;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.LimitSelect;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.LessThan;
import org.jfw.apt.orm.annotation.dao.param.LtEq;
import org.jfw.apt.orm.annotation.dao.param.Set;

@DAO
public interface NotifyMsgDao {

	@Insert
	int insert(Connection con,NotifyMsgIdx msg)throws SQLException;
	@Insert
	int insert(Connection con,NotifyMsgCnt msg)throws SQLException;
	@UpdateWith
	@From(NotifyMsgIdx.class)
	@SetSentence("UN_READ = UN_READ +1")
	int updateIdx(Connection con,@Set String lastCnt,@Set String lastTime,String reciver ) throws SQLException;
	
	@UpdateWith
	@From(NotifyMsgIdx.class)
	int decUnRead(Connection con,String reciver, @Set(" = UN_READ - ?") int unRead ) throws SQLException;
	
	@SelectOne
	@Nullable
	NotifyMsgIdx queryIdx(Connection con,String reciver)throws SQLException;
	
	
	@LimitSelect
	@OrderBy("ORDER BY TIME_DESC DESC")
	List<NotifyMsgCnt> queryCnt(Connection con,String reciver,@LessThan String timeDesc,int rows)throws SQLException;
	
	@UpdateWith
	@From(NotifyMsgCnt.class)
	@SetSentence("READED='1'")
	@Where("READED<>'1'")
	int readed(Connection con,String reciver ,@LtEq String timeDesc)throws SQLException; 
}
