package com.ekexiu.portal.org;

import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.Batch;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.operator.DeleteWith;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectList;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

@DAO
public interface OrgLinkManDao {

	@Insert
	@Batch
	int[] insert(Connection con,OrgLinkMan[] man)throws SQLException;
	
	
	@DeleteWith
	@From(OrgLinkMan.class)
	int deleteByOid(Connection con,String oid)throws SQLException;
	
	@DeleteWith
	@From(OrgLinkMan.class)
	int deleteByPid(Connection con,String pid)throws SQLException;
	
	
	@SelectOne
	@Nullable
	OrgLinkMan queryByPid(Connection con,String pid)throws SQLException;
	
	@SelectList
	@OrderBy("ORDER BY SEQ ASC")
	List<OrgLinkMan> queryByOid(Connection con,String oid)throws SQLException;
	
}
