package com.ekexiu.portal.service;

import java.io.IOException;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.util.StringUtil;

import com.ekexiu.portal.dao.OrgDao;
import com.ekexiu.portal.dao.OrgRetrieveDao;
import com.ekexiu.portal.po.OrgRetrieve;

@Path("/orgRetrieve")
public class OrgRetrieveService {
	@Autowrie
	private OrgRetrieveDao orgRetrieveDao;
	@Autowrie
	private OrgDao orgDao;
	@Autowrie
	private OrgRetrieveImgService orgRetrieveImgService;

	public OrgRetrieveDao getOrgRetrieveDao() {
		return orgRetrieveDao;
	}

	public void setOrgRetrieveDao(OrgRetrieveDao orgRetrieveDao) {
		this.orgRetrieveDao = orgRetrieveDao;
	}
	
	public OrgDao getOrgDao() {
		return orgDao;
	}

	public void setOrgDao(OrgDao orgDao) {
		this.orgDao = orgDao;
	}

	public OrgRetrieveImgService getOrgRetrieveImgService() {
		return orgRetrieveImgService;
	}

	public void setOrgRetrieveImgService(OrgRetrieveImgService orgRetrieveImgService) {
		this.orgRetrieveImgService = orgRetrieveImgService;
	}

	@Post
	@Path
	public void insert(@JdbcConn(true) Connection con,OrgRetrieve orgRetrieve,String[] fns)throws SQLException, IOException{
		String id = StringUtil.buildUUID();
		orgRetrieve.setOrgId(this.orgDao.queryByName(con, orgRetrieve.getName()));
		orgRetrieve.setId(id);
		orgRetrieve.setSolveStatus("1");
		this.orgRetrieveDao.insert(con, orgRetrieve);
		for (String fn : fns) {
			this.orgRetrieveImgService.insertImg(con, id, fn);
		}
	}
	
	@Get
	@Path("/qa")
	public List<OrgRetrieve> query(@JdbcConn Connection con)throws SQLException{
		return this.orgRetrieveDao.query(con);
	}
	
	@Get
	@Path("/queryOne/{id}")
	public OrgRetrieve queryOne(@JdbcConn Connection con,String id)throws SQLException{
		return this.orgRetrieveDao.queryOne(con, id);
	}
}
