package com.ekexiu.portal.service;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.DefaultValue;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.param.JdbcConn;

import com.ekexiu.portal.dao.ProfessorDao;
import com.ekexiu.portal.dao.ResearchAreaLogDao;
import com.ekexiu.portal.pojo.EditProfessor;
import com.ekexiu.portal.pojo.EditResearchAreaLog;

@Path("/researchAreaLog")
public class ResearchAreaLogService {
	public static final String MAX_CREATE_TIME = "9";
	@Autowrie
	private ResearchAreaLogDao researchAreaLogDao;
	@Autowrie
	private ProfessorDao professorDao;
	@Autowrie
	private ImageService imageService;
	
	public ResearchAreaLogDao getResearchAreaLogDao() {
		return researchAreaLogDao;
	}

	public void setResearchAreaLogDao(ResearchAreaLogDao researchAreaLogDao) {
		this.researchAreaLogDao = researchAreaLogDao;
	}

	public ProfessorDao getProfessorDao() {
		return professorDao;
	}

	public void setProfessorDao(ProfessorDao professorDao) {
		this.professorDao = professorDao;
	}

	public ImageService getImageService() {
		return imageService;
	}

	public void setImageService(ImageService imageService) {
		this.imageService = imageService;
	}
	
	@Get
	@Path("/ql")
	public List<EditResearchAreaLog> queryLimit(@JdbcConn Connection con,String professorId,String caption,@DefaultValue("com.ekexiu.portal.service.ResearchAreaLogService.MAX_CREATE_TIME") String createTime,@DefaultValue("10") int rows)throws SQLException{
		List<EditResearchAreaLog> areaLogs = this.researchAreaLogDao.queryLimit(con, professorId, caption, createTime, rows);
		if(!areaLogs.isEmpty()){
			for (EditResearchAreaLog areaLog : areaLogs) {
				EditProfessor professor = this.professorDao.queryBaseInfo(con, areaLog.getOpreteProfessorId());
				professor.setHasHeadImage(this.imageService.hasProfessorImage(professor.getId()));
				areaLog.setProfessor(professor);
			}
		}
		return areaLogs;
	}

}
